﻿Imports C1.WPF
Imports C1.WPF.DataGrid
Imports System.Collections.ObjectModel

Class MainWindow
    Dim ddm As C1DragDropManager

    Public Sub New()

        InitializeComponent()

        c1DataGrid1.ItemsSource = Person.Generate(10)
        c1DataGrid2.ItemsSource = Person.Generate(10)

        ddm = New C1DragDropManager()

        AddHandler c1DataGrid1.LoadedRowPresenter,
            Sub(sender, e)
                ddm.RegisterDropTarget(e.Row.Presenter, True)
                ddm.RegisterDragSource(e.Row.Presenter, DragDropEffect.Copy, ModifierKeys.None)
            End Sub

        AddHandler c1DataGrid2.LoadedRowPresenter,
            Sub(sender, e)
                ddm.RegisterDropTarget(e.Row.Presenter, True)
                ddm.RegisterDragSource(e.Row.Presenter, DragDropEffect.Copy, ModifierKeys.None)
            End Sub

        AddHandler ddm.DragStart,
            Sub(sender, e)
                Dim row As C1.WPF.DataGrid.DataGridRow = CType(e.DragSource, DataGridRowPresenter).Row
                Dim mark As String = row.DataItem.ToString()

                Dim border As Border = CType(ddm.TargetMarker, Border)
                border.Height = 32D
                border.Child = New ContentControl() With
                {
                    .Foreground = New SolidColorBrush(Colors.Black),
                    .FontSize = 16D,
                    .FontWeight = FontWeights.DemiBold,
                    .Content = mark
                }
            End Sub

        AddHandler ddm.DragDrop,
            Sub(sender, e)
                Dim source_row = CType(e.DragSource, DataGridRowPresenter).Row
                Dim source_table = source_row.DataGrid

                Dim target_row = CType(e.DropTarget, DataGridRowPresenter).Row
                Dim target_table = target_row.DataGrid

                If Not source_table Is target_table Then
                    CType(source_table.ItemsSource, ObservableCollection(Of Person)).Remove(CType(source_row.DataItem, Person))
                    CType(target_table.ItemsSource, ObservableCollection(Of Person)).Add(CType(source_row.DataItem, Person))
                Else
                    System.Media.SystemSounds.Beep.Play()
                End If
            End Sub
    End Sub
End Class
